/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { Transaction transaction = new Transaction(commandData.Application.ActiveUIDocument.Document, "External Tool"); try { transaction.Start(); Wall wall = null; Floor floor = null; ElementSet elems = new ElementSet(); foreach (ElementId elementId in commandData.Application.ActiveUIDocument.Selection.GetElementIds()) { elems.Insert(commandData.Application.ActiveUIDocument.Document.GetElement(elementId)); } #region selection error handle //if user have some wrong selection, give user an error message if (1 != elems.Size) { message = "please selected one Object (Floor or Wall) to create Opening."; return(Autodesk.Revit.UI.Result.Cancelled); } Autodesk.Revit.DB.Element selectElem = null; foreach (Autodesk.Revit.DB.Element e in elems) { selectElem = e; } if (!(selectElem is Wall) && !(selectElem is Floor)) { message = "please selected one Object (Floor or Wall) to create Opening."; return(Autodesk.Revit.UI.Result.Cancelled); } #endregion try { if (selectElem is Wall) { wall = selectElem as Wall; ProfileWall profileWall = new ProfileWall(wall, commandData); NewOpeningsForm newOpeningsForm = new NewOpeningsForm(profileWall); newOpeningsForm.ShowDialog(); } else if (selectElem is Floor) { floor = selectElem as Floor; ProfileFloor profileFloor = new ProfileFloor(floor, commandData); NewOpeningsForm newOpeningsForm = new NewOpeningsForm(profileFloor); newOpeningsForm.ShowDialog(); } } catch (Exception ex) { message = ex.Message; return(Autodesk.Revit.UI.Result.Cancelled); } return(Autodesk.Revit.UI.Result.Succeeded); } catch (Exception e) { message = e.Message; return(Autodesk.Revit.UI.Result.Failed); } finally { transaction.Commit(); } }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { Transaction transaction = new Transaction(commandData.Application.ActiveUIDocument.Document, "External Tool"); try { transaction.Start(); Wall wall = null; Floor floor = null; ElementSet elems = commandData.Application.ActiveUIDocument.Selection.Elements; #region selection error handle //if user have some wrong selection, give user an error message if (1 != elems.Size) { message = "please selected one Object (Floor or Wall) to create Opening."; return Autodesk.Revit.UI.Result.Cancelled; } Autodesk.Revit.DB.Element selectElem = null; foreach (Autodesk.Revit.DB.Element e in elems) { selectElem = e; } if (!(selectElem is Wall) && !(selectElem is Floor)) { message = "please selected one Object (Floor or Wall) to create Opening."; return Autodesk.Revit.UI.Result.Cancelled; } #endregion try { if (selectElem is Wall) { wall = selectElem as Wall; ProfileWall profileWall = new ProfileWall(wall, commandData); NewOpeningsForm newOpeningsForm = new NewOpeningsForm(profileWall); newOpeningsForm.ShowDialog(); } else if (selectElem is Floor) { floor = selectElem as Floor; ProfileFloor profileFloor = new ProfileFloor(floor, commandData); NewOpeningsForm newOpeningsForm = new NewOpeningsForm(profileFloor); newOpeningsForm.ShowDialog(); } } catch (Exception ex) { message = ex.Message; return Autodesk.Revit.UI.Result.Cancelled; } return Autodesk.Revit.UI.Result.Succeeded; } catch (Exception e) { message = e.Message; return Autodesk.Revit.UI.Result.Failed; } finally { transaction.Commit(); } }